#include <iostream>
#include <cstring>

using namespace std;
/*
string rotiraj(string s,int l,int r)
{

    int pokreni=0;
    for(int i=0;i<s.length();i++)
       {if(s[i]=='1')
       {
           pokreni=1;
       }
      if(pokreni==1)
        if(i>=l-1 && i<=r-1)
            if(s[i]=='0')
                s[i]='1';
            else
                s[i]='0';
       }
       cout<<s<<"\n";
    return s;
}
int prebroje(string s)
{
    int jed=0;
    int nul=0;
     for(int i=0;i<s.length();i++)
        if(s[i]!='0')
                jed++;
            else
                nul++;
    if(jed>nul)
        return 1;
    else
        return 0;
}*/
int brnula(string s)
{
    int nul=0;
     for(int i=0;i<s.length();i++)
        if(s[i]!='0')
                nul++;
        return nul;
}
int brjedinica(string s)
{
    int jed=0;
     for(int i=0;i<s.length();i++)
        if(s[i]!='0')
                jed++;
        return jed;
}
int finale(string s)
{   int finalno=0;
    int brojac=0;
    int brojnula=brnula(s);
    int brojjedinica=brjedinica(s);

      for(int i=0;i<s.length();i++)
      {
          if(s[i]=='0' && brojnula<brojjedinica)
          {
            if(brojac>=2)
            {
                finalno=finalno+2;
            }
            else if(brojac>0)
                finalno++;
            brojac=0;
          }
          else
          {
           brojac++;
          }
      }
        if(brojac>=2)
        {
            finalno=finalno+2;
        }
        else if(brojac>0)
                finalno++;
      return finalno;
}
int main()
{
    string s;
    string novi;
    int n,c,q;
    cin>>n>>c>>q;
    cin>>s;
    while(q-->0)
    {
        int l,r;
        cin>>l>>r;

        cout<<finale(novi)<<"\n";

    }
    return 0;
}